/*****************************************************************************/
/*/
   /* THIS SOFTWARE AND AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS." */
/* THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,    */
/* CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,   */
/* WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A    */
/* PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE FOR   */
/* ANY DAMAGES, INCLUDING ANT LOST PROFITS, LOST SAVINGS OR OTHER            */
/* INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR INABILITY  */
/* TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION, EVEN IF          */
/* INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES."                  */
/*/
   /**************************************************************************** */
/************************************************************************/
/*/
   /* Subroutine: put_hex.c                                                 */
/*/
   /* Created: 19 Dec 1994 by F. C. Betts - Veda Incorporated               */
/*/
   /* Purpose: put_hex processes each string defined as hex.                */
/*/
   /* Last Update: work in progress 31 Jan 1995 by fcb                      */
/* 23 Feb 1995 changed to 1024 BUFFSIZ1 by fcb           */
/*/
   /*********************************************************************** */
#include <stdio.h>		/* needed for standard i/o  */
#include <string.h>		/* needed for string functions */
#include "phxlate.h"

int
put_hex (write_buff)
     char *write_buff;

{
  extern int data_address_start;	/* location of first byte of data */
  extern int data_address_end;	/* location of last byte of data */
  extern char buff[BUFFSIZ1];
  int ipoint = 0, ipointw;
  char temp_buff[150];

  /* these declarations should be unsigned char for sun applications */
  /* and just char for sgi applications */
  unsigned char temp_char;
  unsigned char temp_hex[3];

  /* printf("\nhex processing, st,end=%d,%d\n",data_address_start,
   * data_address_end); */

  /* set the temp buffer to nulls */
  memset (temp_buff, '\0', 150);

  /* print the buffer one character at a time */
  for (ipointw = data_address_start - 1; ipointw < data_address_end; ipointw++)
    {
      temp_char = buff[ipointw];
      /* printf("put_hex ipoint=%d, temp_char=%2.2x, ipointw=%d\n",ipoint,
         * temp_char,ipointw);  */

      /* write data to the hex buffer */
      sprintf (temp_hex, "%2.2x", temp_char);
      /* printf("put_hex temp_hex_string=>%s<\n",temp_hex); */

      /* copy hex data to temp buffer */
      memcpy (&temp_buff[ipoint], temp_hex, 2);
      ipoint += 2;
    }

  /* copy the result to the output buffer */
  strcpy (write_buff, temp_buff);
  /* printf("put_hex string =>%s<\n",write_buff); */

  /* all done - leave */
  return (0);
}
